/*
 * db.h
 *
 *  Created on: 2009/10/09
 *      Author: shu
 */

#ifndef DB_H_
#define DB_H_
#include "encoder.h"
#include "chunk.h"
#include <string>
#include <stdint.h>

using namespace std;

class SequenceIndex;

class Db {
public:
  static string GetInformationFileName(string filename_prefix) {
    return filename_prefix + ".inf";
  }

  Db(string filename_prefix);
  virtual ~Db();

  void SetChunk(uint32_t id);
  void ResetChunk();
  bool NextChunk();

  uint32_t GetNumberChunks() {
    return number_chunks_;
  }

  uint32_t GetMaxChunkLength() {
    return max_length_;
  }

  uint32_t GetChunkId() {
    return chunk_id_;
  }

  uint32_t GetNumberSequences() {
    return chunk_->GetNumberSequences();
  }

  uint32_t GetConcatenatedSequenceLength() {
    return chunk_->GetConcatenatedSequenceLength();
  }

  string GetName(uint32_t id) {
    return chunk_->GetName(id);
  }

  uint32_t GetOffset(uint32_t id) {
    return chunk_->GetOffsets(id);
  }

  Code *GetConcatenatedSequence() {
    return chunk_->GetConcatenatedSequence();
  }

  void ClearConcatenatedSequence() {
    return chunk_->ClearConcatenatedSequence();
  }

  uint32_t GetId(uint32_t position) {
    return chunk_->GetId(position);
  }

  SequenceIndex *GetIndex() {
    return chunk_->GetIndex();
  }

  uint64_t GetDBLenght() {
    return db_length_;
  }

  uint64_t GetNumberSequencesInDB() {
    return number_sequences_;
  }

private:
  string filename_prefix_;
  uint32_t number_chunks_;
  uint32_t max_length_;
  uint32_t chunk_id_;
  Chunk *chunk_;
  uint64_t db_length_;
  uint64_t number_sequences_;

};


#endif /* DB_H_ */
